library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.all;
--use IEEE.STD_LOGIC_ARITH.ALL;
--use IEEE.STD_LOGIC_UNSIGNED.ALL;
--use work.dff;

entity COUNTER is
	generic (
          WIDTH: integer:=32
          );
	port (
          Q : out STD_LOGIC_VECTOR(WIDTH-1 downto 0)
          ;CE : in STD_LOGIC
          ;EN : in STD_LOGIC
          ;CLR : in STD_LOGIC
          ;CLK : in STD_LOGIC
          );
end COUNTER;

architecture behavioral of COUNTER is
  signal COUNT : UNSIGNED(WIDTH-1 downto 0);
begin

process(CLK, CLR)
begin
  if (CLR='1') then
    COUNT(WIDTH-1 downto 0) <= (others => '0');
  elsif (CLK'event) then
    if (EN='1' and CE='1') then 
      COUNT(WIDTH-1 downto 0) <= COUNT+1;
    end if;
  end if;
end process;

-- assign output
Q<=STD_LOGIC_VECTOR(COUNT);

end behavioral;
